import os

# Retrieve the list of XCF's from the directory

os.chdir('/home/bassam/final_boards/script_test/unsequenced/')
cwd = os.getcwd()
list_of_xcfs = []

for name in os.listdir(cwd):
    path = os.path.join(cwd, name)
    if os.path.isfile(path):
        if '.xcf' in name:
            name_split = str(name.split('.')[0])
            list_of_xcfs.append(name_split)

# CREATE THE UI
#make the properties
StringProperty = bpy.types.Scene.StringProperty

for index, item in enumerate(list_of_xcfs):
    StringProperty(attr="file_no:"+str(index), name="file_no:"+str(index), description=item+' description')
    bpy.context.scene["file_no:"+str(index)] = item

#make the operators
def invoke_func(self, context, event):
    scene = context.scene
    sequences = context.scene.sequence_editor.sequences
    compare = self.re_name.split('+')
    prop_name = compare[0].strip()
    new_name = scene[compare[0].strip()]
    old_name = compare[1].strip()

    if new_name != old_name:
        os.chdir('/home/bassam/final_boards/script_test/unsequenced/')
        cwd = os.getcwd()
        cmd = 'mv '+ old_name + '.xcf' + ' ' + new_name + '.xcf'
        os.popen(cmd)

        os.chdir('/home/bassam/final_boards/script_test/unsequenced/pngs/')
        cwd = os.getcwd()

        for name in os.listdir(cwd):
            path = os.path.join(cwd, name)
            if os.path.isfile(path):
                if old_name[4:] in name:
                    cmd = 'mv ' + name + ' ' + new_name[:4] + name[4:]
                    os.popen(cmd)
                    

        os.chdir('/home/bassam/final_boards/script_test/unsequenced/pngs/animated/')
        cwd = os.getcwd()

        for name in os.listdir(cwd):
            path = os.path.join(cwd, name)
            if os.path.isfile(path):
                if old_name[4:] in name:
                    cmd = 'mv ' + name + ' ' + new_name[:4] + name[4:]
                    os.popen(cmd)

        for sequence in sequences:
            file_name = sequence.elements[0].filename.split('.')[0].strip()[4:]
            print(old_name[4:] + ' AND ' + file_name)
            if old_name[4:] in file_name:
                sequence.elements[0].filename = new_name[:4] + file_name + '.png'           
                         

        return {'FINISHED'}
            
    else:
        return {'FINISHED'}
    
for index, item in enumerate(list_of_xcfs):
    c = type(item, (bpy.types.Operator,), dict(bl_idname="SEQUENCER_OT_"+item, bl_label="SEQUENCER_OT_"+item, bl_description=item, re_name='%s + %s' %('file_no:'+str(index), item)))
    setattr(c, 'invoke', invoke_func)
    bpy.types.register(c)
    
class SEQUENCER_PT_file_names(bpy.types.Panel):
    bl_label = 'file_rename'
    bl_space_type = 'SEQUENCE_EDITOR'
    bl_region_type = 'UI'

    def draw(self, context):
        layout = self.layout
        scene = context.scene

        for index, item in enumerate(list_of_xcfs):
            row = layout.row()
            split = row.split(percentage = 0.9)
            colL = split.column()
            colR = split.column()
            
            colL.prop(scene, "file_no:"+str(index), text=item)
            colR.operator('sequencer.'+item, text='rename')

bpy.types.register(SEQUENCER_PT_file_names)
